// src/attachable/asAttachableInstance.ts
import { AsObjectFactory as AsObjectFactory2 } from "@xylabs/object";

// src/attachable/isAttachableInstance.ts
import { IsObjectFactory } from "@xylabs/object";
import { isAttachableModuleInstance } from "@xyo-network/module-model";

// src/typeChecks.ts
import { AsObjectFactory } from "@xylabs/object";
import {
  IsInstanceFactory,
  IsModuleFactory,
  isModuleInstance,
  WithFactory
} from "@xyo-network/module-model";

// src/Queries/Connect.ts
var BridgeConnectQuerySchema = "network.xyo.query.bridge.connect";

// src/Queries/Disconnect.ts
var BridgeDisconnectQuerySchema = "network.xyo.query.bridge.disconnect";

// src/Queries/Expose.ts
var BridgeExposeQuerySchema = "network.xyo.query.bridge.expose";
var ModuleFilterPayloadSchema = "network.xyo.module.filter";

// src/Queries/Unexpose.ts
var BridgeUnexposeQuerySchema = "network.xyo.query.bridge.unexpose";

// src/typeChecks.ts
var isBridgeInstance = new IsInstanceFactory().create(
  { expose: "function" },
  [isModuleInstance]
);
var isBridgeModule = new IsModuleFactory().create([BridgeConnectQuerySchema, BridgeDisconnectQuerySchema]);
var asBridgeModule = AsObjectFactory.create(isBridgeModule);
var asBridgeInstance = AsObjectFactory.create(isBridgeInstance);
var withBridgeModule = WithFactory.create(isBridgeModule);
var withBridgeInstance = WithFactory.create(isBridgeInstance);

// src/attachable/isAttachableInstance.ts
var requiredAttachableBridgeInstanceFunctions = {};
var factory = new IsObjectFactory();
var isAttachableBridgeInstance = factory.create(requiredAttachableBridgeInstanceFunctions, [
  isBridgeInstance,
  isAttachableModuleInstance
]);

// src/attachable/asAttachableInstance.ts
var asAttachableBridgeInstance = AsObjectFactory2.create(isAttachableBridgeInstance);

// src/attachable/AttachableInstance.ts
import { IsObjectFactory as IsObjectFactory2 } from "@xylabs/object";
var IsAttachableBridgeInstanceFactory = class extends IsObjectFactory2 {
};

// src/Config.ts
var BridgeConfigSchema = "network.xyo.bridge.config";
export {
  BridgeConfigSchema,
  BridgeConnectQuerySchema,
  BridgeDisconnectQuerySchema,
  BridgeExposeQuerySchema,
  BridgeUnexposeQuerySchema,
  IsAttachableBridgeInstanceFactory,
  ModuleFilterPayloadSchema,
  asAttachableBridgeInstance,
  asBridgeInstance,
  asBridgeModule,
  isAttachableBridgeInstance,
  isBridgeInstance,
  isBridgeModule,
  requiredAttachableBridgeInstanceFunctions,
  withBridgeInstance,
  withBridgeModule
};
//# sourceMappingURL=index.mjs.map